include \masm32\include\masm32rt.inc
.686
include \masm32\macros\timers.asm
.xmm

.data
align 16
TheAnd	oword 0ff000000ff000000ff000000ff000000h
Src	db "RGBArgbaRGB1rgb1", 0
align 16
Dest	db "BGRAbgraBGR1bgr1", 0
align 16
Src1000	dd 1000 dup(0)

.code
;=====================================================================
start:
	invoke AllocConsole
	push 16
	push offset Src
	call RgbSwapSSE
	print "Test for correctness:", 13, 10
	print offset Src, 13, 10

	push 1
	push offset Src
	call RgbSwapSSE2
	print offset Src, 13, 10

	push 16
	push offset Src
	call RgbSwapH
	print offset Src, 13, 10

	push 16
	push offset Src
	call RgbSwapH2
	print offset Src, 13, 10

	push 16
	push offset Src
	call RgbSwap
	print offset Src, 13, 10

	print offset Dest, 13, 10, 10
if 0
	exit
else
    invoke Sleep, 200
    counter_begin 1000, HIGH_PRIORITY_CLASS
    	push 1000
    	push offset Src1000
    	call RgbSwap
    counter_end
    print ustr$(eax)," cycles for RgbSwap MichaelW",13,10

    invoke Sleep, 200
    counter_begin 1000, HIGH_PRIORITY_CLASS
    	push 1000
    	push offset Src1000
    	call RgbSwapH
    counter_end
    print ustr$(eax)," cycles for RgbSwap Hutch",13,10

    invoke Sleep, 200
    counter_begin 1000, HIGH_PRIORITY_CLASS
    	push 1000/4
    	push offset Src1000
    	call RgbSwapSSE2
    counter_end
    print ustr$(eax)," cycles for RgbSwapSSE2 qWord",13,10

    invoke Sleep, 200
    counter_begin 1000, HIGH_PRIORITY_CLASS
    	push 1000
    	push offset Src1000
    	call RgbSwapH2
    counter_end
    print ustr$(eax)," cycles for RgbSwap Hutch2",13,10

    invoke Sleep, 200
    counter_begin 1000, HIGH_PRIORITY_CLASS
    	push 1000
    	push offset Src1000
    	call RgbSwapSSE
    counter_end
    print ustr$(eax)," cycles for RgbSwapSSE",13,10

    counter_begin 1000, HIGH_PRIORITY_CLASS
    counter_end
    print ustr$(eax)," cycles",13,10,13,10

    inkey "Press any key to exit..."
    exit
endif

RgbSwapSSE proc ; Src, Bytes
	pop eax	; ret address
	pop edx	; Src
	pop ecx	; Bytes
	shr ecx, 1	; we process 8 bytes a time
@@:	dec ecx
	movq xmm1, qword ptr [edx+8*ecx]
	pxor xmm0, xmm0	; xmm0 may contain garbage
	punpcklbw xmm0, xmm1	; expand 8 bytes to 8 xmm0 words
	pshufd xmm0, xmm0, 00011011b	; inspired by [url=http://www.asmcommunity.net/board/index.php?topic=29743.0]drizz[/url]
	pshuflw xmm0, xmm0, 10110001b
	pshufhw xmm0, xmm0, 10110001b	; all words swapped
	pshufd xmm0, xmm0, 01001110b	; switch low dwords
	psrlq xmm0, 24	; shift right by three bytes
	pxor xmm2, xmm2
	pand xmm1, TheAnd
	packsswb xmm0, xmm2	; pack words to bytes
	paddb xmm0, xmm1
	movq qword ptr [edx+8*ecx], xmm0	; back to mem, 8 bytes
	test ecx, ecx
	jne @B
		jmp eax
RgbSwapSSE endp

align 16
RgbSwapSSE2 proc ; Src, n4Pixels
    pop eax ; ret address
    pop edx ; Src
    pop ecx ; N*4 pixels
    pxor xmm2,xmm2
    align 16
@@: dec ecx 
    movdqa xmm0,[edx]
    movdqa xmm1,xmm0    ; movdqa xmm1,[edx]
    psllw xmm0,8
    psrlw xmm1,8
    pshuflw xmm0,xmm0,10110001y
    pshufhw xmm0,xmm0,10110001y
    psrldq xmm0,1
    pslldq xmm1,1
    por xmm0,xmm1
    movdqa [edx],xmm0
    lea edx,[edx+16]    
    test ecx, ecx
    jne @B
@@: jmp eax
RgbSwapSSE2 endp

RgbSwapH proc uses edi rsSrc, rsBytes
	mov ecx, rsBytes
	mov edi, rsSrc
	shr ecx, 1
@@:
	mov al, BYTE PTR [edi]
	mov dl, BYTE PTR [edi+2]
	mov [edi], dl
	mov [edi+2], al
	mov al, BYTE PTR [edi+4]
	mov dl, BYTE PTR [edi+2+4]
	mov [edi+4], dl
	mov [edi+2+4], al
	add edi, 8
	dec ecx
	jne @B
	ret
RgbSwapH endp

RgbSwapH2 proc uses edi rsSrc, rsBytes
	mov ecx, rsBytes
	mov edi, rsSrc
	shr ecx, 2
@@:
	mov al, BYTE PTR [edi]
	mov dl, BYTE PTR [edi+2]
	mov [edi], dl
	mov [edi+2], al
	mov al, BYTE PTR [edi+4]
	mov dl, BYTE PTR [edi+2+4]
	mov [edi+4], dl
	mov [edi+2+4], al
	mov al, BYTE PTR [edi+8]
	mov dl, BYTE PTR [edi+2+8]
	mov [edi+8], dl
	mov [edi+2+8], al
	mov al, BYTE PTR [edi+12]
	mov dl, BYTE PTR [edi+2+12]
	mov [edi+12], dl
	mov [edi+2+12], al
	add edi, 16
	dec ecx
	jne @B
	ret
RgbSwapH2 endp

RgbSwap proc uses edi rsSrc, rsBytes
	UF=4
	DISP=0
	mov ecx, rsBytes
	mov edi, rsSrc
@@:	sub ecx, UF
;	int 3
	REPEAT UF
		mov eax, [edi+ecx*4+DISP]
		mov edx, eax
		bswap eax
		and edx, 0ff000000h
		shr eax, 8
		or eax, edx
		mov [edi+ecx*4+DISP], eax
		DISP=DISP+4
	ENDM
	test ecx, ecx
	ja @B
	ret
RgbSwap endp


end start

OPT_Wait	1
OPT_Olly	2
OPT_Tmp2Asm	1
